petsc-3.7.1 2016-05-15
Report Typos and Errors

# VecSetValuesBlocked

Inserts or adds blocks of values into certain locations of a vector.

### Synopsis

    #include "petscvec.h"
    PetscErrorCode  VecSetValuesBlocked(Vec x,PetscInt ni,const PetscInt ix[],const PetscScalar y[],InsertMode iora)

Not Collective Many br

### Input Parameters

| x | - vector to insert in Many br
| ni | - number of blocks to add Many br
| ix | - indices where to add in block count, rather than element count Many br
| y | - array of values Many br
| iora | - either INSERT_VALUES or ADD_VALUES, where Many brADD_VALUES adds values to any existing entries, and Many brINSERT_VALUES replaces existing entries with new values Many br

### Notes

VecSetValuesBlocked() sets x[bs*ix[i]+j] = y[bs*i+j], Many brfor j=0,...,bs-1, for i=0,...,ni-1. where bs was set with VecSetBlockSize(). Many br

Calls to VecSetValuesBlocked() with the INSERT_VALUES and ADD_VALUES Many broptions cannot be mixed without intervening calls to the assembly Many brroutines. Many br

These values may be cached, so VecAssemblyBegin() and VecAssemblyEnd() Many brMUST be called after all calls to VecSetValuesBlocked() have been completed. Many br

VecSetValuesBlocked() uses 0-based indices in Fortran as well as in C. Many br

Negative indices may be passed in ix, these rows are Many brsimply ignored. This allows easily inserting element load matrices Many brwith homogeneous Dirchlet boundary conditions that you don't want represented Many brin the vector. Many br

Many br

### See Also

VecAssemblyBegin(), VecAssemblyEnd(), VecSetValuesBlockedLocal(),
VecSetValues() Many br

Level:intermediate
Location:src/vec/vec/interface/rvector.c
Index of all Vec routines
Table of Contents for all manual pages
Index of all manual pages

### Examples

src/ksp/ksp/examples/tutorials/ex56.c.html